// DIMEMapper.h : Declaration of the CDIMEMapper

#ifndef __DIMEMAPPER_H_
#define __DIMEMAPPER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CDIMEMapper
class ATL_NO_VTABLE CDIMEMapper : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CDIMEMapper, &CLSID_DIMEMapper>,
	public IDispatchImpl<ISoapTypeMapper, &IID_ISoapTypeMapper, &LIBID_MSSOAPLib30>
{
public:
	CDIMEMapper()
	{
		m_pUnkMarshaler = NULL;
	}

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

DECLARE_REGISTRY_RESOURCEID(IDR_DIMEMAPPER)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDIMEMapper)
	COM_INTERFACE_ENTRY(ISoapTypeMapper)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

public:
// ISoapTypeMapper
	STDMETHOD(Init)(ISoapTypeMapperFactory * par_Factory, IXMLDOMNode * par_Schema, IXMLDOMNode * par_WSMLNode, enXSDType par_xsdType);
	STDMETHOD(Read)(ISoapReader * par_soapreader, IXMLDOMNode * par_Node, BSTR par_encoding, enEncodingStyle par_encodingMode, LONG par_flags, VARIANT * par_var);
	STDMETHOD(Write)(ISoapSerializer * par_ISoapSerializer, BSTR par_encoding, enEncodingStyle par_encodingMode, LONG par_flags, VARIANT * par_var);
	STDMETHOD(VarType)(LONG * par_Type);
	STDMETHOD(Iid)(BSTR * par_IIDAsString);
	STDMETHOD(SchemaNode)(IXMLDOMNode * * par_SchemaNode);
	STDMETHOD(XsdType)(enXSDType * par_xsdType);

    
    CComPtr<IXMLDOMNode> m_spSchema, m_spWSML;    
};

#endif //__DIMEMAPPER_H_
