// Connector.h : Declaration of the CConnector

#ifndef __CONNECTOR_H_
#define __CONNECTOR_H_

#include "resource.h"       // main symbols
#include "InputStream.h"
#include "OutputStream.h"
#include "MemStream.h"
/////////////////////////////////////////////////////////////////////////////
// CConnector
class ATL_NO_VTABLE CConnector : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CConnector, &CLSID_Connector>,
	public ISupportErrorInfo,
    public IDispatchImpl<ISoapConnector, &IID_ISoapConnector, &LIBID_MSSOAPLib30>
{
public:
	CConnector()
	{
	}

    HRESULT FinalConstruct();

DECLARE_REGISTRY_RESOURCEID(IDR_CONNECTOR)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CConnector)
	COM_INTERFACE_ENTRY(ISoapConnector)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// ISoapConnector
public:
    STDMETHOD(get_InputStream) (IStream * * pVal );
    STDMETHOD(get_OutputStream)(IStream * * pVal );
    STDMETHOD(get_Property)(BSTR pPropertyName,VARIANT * pPropertyValue );
    STDMETHOD(put_Property)(BSTR pPropertyName,VARIANT pPropertyValue );
    STDMETHOD(ConnectWSDL)(IWSDLPort * pPort );
    STDMETHOD(Reset)( );
    STDMETHOD(BeginMessageWSDL)(IWSDLOperation * pOperation );
    STDMETHOD(EndMessage)( );
    STDMETHOD(Connect)( );
    STDMETHOD(BeginMessage)( );


    HRESULT send(const void* pb, ULONG cb);
    HRESULT receive(void* pb, ULONG cb, ULONG* pcbRead);
    HRESULT get_property(const _bstr_t& name, _bstr_t& value);
    HRESULT set_property(const _bstr_t& name, const _bstr_t& value);

private:
    XML::IXMLHTTPRequestPtr m_spRequest;
    CComPtr<CInputStream> m_pInput;
    CComPtr<COutputStream> m_pOutput;
    CComPtr<CMemStream> m_pMemStream;
    IStreamPtr m_spStm;

    bool m_bContentTypeSet;    

    bool m_bAsync;
    DWORD m_nCallInterval;
    CComPtr<IAsyncSOAPCall> m_spClient;
    CComBSTR m_bstrURL;
};

#endif //__CONNECTOR_H_
