// InputStream.cpp : Implementation of CInputStream
#include "stdafx.h"
#include "SimpleConnector.h"
#include "InputStream.h"
#include "Connector.h"
/////////////////////////////////////////////////////////////////////////////
// CInputStream
void CInputStream::init(CConnector* pConn)
{
    m_pConn = pConn;
}

HRESULT CInputStream::FinalConstruct()
{
    m_pb = 0;
    m_cb = 0;
    create_object<CMemStream>(m_pMemStream);
    return S_OK;
}

void CInputStream::FinalRelease()
{
    if(m_pb)
    {
        delete[] m_pb;
        m_pb = 0;
    }
}

// IStream
STDMETHODIMP CInputStream::Seek(_LARGE_INTEGER /*dlibMove*/, ULONG /*dwOrigin*/, _ULARGE_INTEGER * /*plibNewPosition*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::SetSize(_ULARGE_INTEGER /*libNewSize*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::CopyTo(IStream * /*pstm*/, _ULARGE_INTEGER /*cb*/, _ULARGE_INTEGER * /*pcbRead*/, _ULARGE_INTEGER * /*pcbWritten*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::Commit(ULONG /*grfCommitFlags*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::Revert()
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::LockRegion(_ULARGE_INTEGER /*libOffset*/, _ULARGE_INTEGER /*cb*/, ULONG /*dwLockType*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::UnlockRegion(_ULARGE_INTEGER /*libOffset*/, _ULARGE_INTEGER /*cb*/, ULONG /*dwLockType*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::Stat(tagSTATSTG * /*pstatstg*/, ULONG /*grfStatFlag*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::Clone(IStream * * /*ppstm*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CInputStream::Read(void * /*pv*/, ULONG /*cb*/, ULONG * /*pcbRead*/)
{
    return E_NOTIMPL;
}

STDMETHODIMP CInputStream::Write(const void * pv, ULONG cb, ULONG * pcbWritten)
{
    HRESULT hr = m_pConn->send(pv, cb);
    if((SUCCEEDED(hr)) && pcbWritten)
        *pcbWritten = cb;
    return hr;
}

STDMETHODIMP CInputStream::put_TotalSize(LONG sz)
{
    m_cb = sz;
    return S_OK;
}

STDMETHODIMP CInputStream::get_Property(BSTR /*par_name*/, VARIANT * /*par_value*/)
{
    return S_OK;
}

STDMETHODIMP CInputStream::put_Property(BSTR par_name, VARIANT par_value)
{
    CComVariant v = par_value;
    HRESULT hr = v.ChangeType(VT_BSTR);
    if(SUCCEEDED(hr))
        hr = m_pConn->set_property(par_name, v.bstrVal);
    return hr;
}

STDMETHODIMP CInputStream::BeginSending(ISequentialStream * * par_stream, ComposerDestinationFlags * /*par_flags*/)
{
    if(m_pb)
    {
        delete[] m_pb;
        m_pb = 0;
    }
    m_pb = new BYTE[m_cb];
    m_pMemStream->init( m_pb, m_cb );
    *par_stream = IStreamPtr(m_pMemStream).Detach();
    return S_OK;
}

STDMETHODIMP CInputStream::EndSending()
{
    HRESULT hr = m_pConn->send(m_pb, m_cb);
    if(m_pb)
    {
        delete[] m_pb;
        m_pb = 0;
    }
    return hr;
}

// IGetComposerDestination
STDMETHODIMP CInputStream::get_ComposerDestination(IComposerDestination * * par_value)
{
    *par_value = IComposerDestinationPtr(GetUnknown()).Detach();
    return S_OK;
}
