// InputStream.h : Declaration of the CInputStream

#ifndef __INPUTSTREAM_H_
#define __INPUTSTREAM_H_

#include "resource.h"       // main symbols
#include "MemStream.h"
class CConnector;
/////////////////////////////////////////////////////////////////////////////
// CInputStream
class ATL_NO_VTABLE CInputStream : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CInputStream, &CLSID_InputStream>,
	public ISupportErrorInfoImpl<&IID_IStream>,
	public IStream,
	public IComposerDestination,
	public IGetComposerDestination
{
public:
	CInputStream()
	{
	}

    HRESULT FinalConstruct();

    void FinalRelease();
DECLARE_REGISTRY_RESOURCEID(IDR_INPUTSTREAM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CInputStream)
	COM_INTERFACE_ENTRY(IStream)
    COM_INTERFACE_ENTRY(ISupportErrorInfo)
    COM_INTERFACE_ENTRY(IComposerDestination)
    COM_INTERFACE_ENTRY(IGetComposerDestination)
END_COM_MAP()

    void init(CConnector* pConn);

public:


private:
    CConnector* m_pConn;

public:    
// IStream
	STDMETHOD(Seek)(_LARGE_INTEGER dlibMove, ULONG dwOrigin, _ULARGE_INTEGER * plibNewPosition);
	STDMETHOD(SetSize)(_ULARGE_INTEGER libNewSize);
	STDMETHOD(CopyTo)(IStream * pstm, _ULARGE_INTEGER cb, _ULARGE_INTEGER * pcbRead, _ULARGE_INTEGER * pcbWritten);
	STDMETHOD(Commit)(ULONG grfCommitFlags);
	STDMETHOD(Revert)();
	STDMETHOD(LockRegion)(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, ULONG dwLockType);
	STDMETHOD(UnlockRegion)(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, ULONG dwLockType);
	STDMETHOD(Stat)(tagSTATSTG * pstatstg, ULONG grfStatFlag);
	STDMETHOD(Clone)(IStream * * ppstm);
	STDMETHOD(Read)(void * pv, ULONG cb, ULONG * pcbRead);
	STDMETHOD(Write)(const void * pv, ULONG cb, ULONG * pcbWritten);
// IComposerDestination
	STDMETHOD(put_TotalSize)(LONG );
	STDMETHOD(get_Property)(BSTR par_name, VARIANT * par_value);
	STDMETHOD(put_Property)(BSTR par_name, VARIANT par_value);
	STDMETHOD(BeginSending)(ISequentialStream * * par_stream, ComposerDestinationFlags * par_flags);
	STDMETHOD(EndSending)();
// IGetComposerDestination
	STDMETHOD(get_ComposerDestination)(IComposerDestination * * par_value);

    
private:
    CComPtr<CMemStream> m_pMemStream;
    ULONG m_cb;
    BYTE* m_pb;
};

#endif //__INPUTSTREAM_H_
