// MemStream.cpp : Implementation of CMemStream
#include "stdafx.h"
#include "SimpleConnector.h"
#include "MemStream.h"

/////////////////////////////////////////////////////////////////////////////
// CMemStream

void CMemStream::init(void* pb, ULONG cb)
{
    m_pb = reinterpret_cast<BYTE*>(pb);
    m_cb = cb;
    m_seekptr = 0;
}

// IStream
STDMETHODIMP CMemStream::Seek(_LARGE_INTEGER /*dlibMove*/, ULONG /*dwOrigin*/, _ULARGE_INTEGER * /*plibNewPosition*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::SetSize(_ULARGE_INTEGER /*libNewSize*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::CopyTo(IStream * /*pstm*/, _ULARGE_INTEGER /*cb*/, _ULARGE_INTEGER * /*pcbRead*/, _ULARGE_INTEGER * /*pcbWritten*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::Commit(ULONG /*grfCommitFlags*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::Revert()
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::LockRegion(_ULARGE_INTEGER /*libOffset*/, _ULARGE_INTEGER /*cb*/, ULONG /*dwLockType*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::UnlockRegion(_ULARGE_INTEGER /*libOffset*/, _ULARGE_INTEGER /*cb*/, ULONG /*dwLockType*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::Stat(tagSTATSTG * /*pstatstg*/, ULONG /*grfStatFlag*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::Clone(IStream * * /*ppstm*/)
{
    return E_NOTIMPL;
}
STDMETHODIMP CMemStream::Read(void * pv, ULONG cb, ULONG * pcbRead)
{
    ObjectLock lock_(this);
    ULONG toread = min(cb , m_cb - m_seekptr);
    memcpy(pv, m_pb + m_seekptr, toread);
    m_seekptr += toread;
    if(pcbRead)
        *pcbRead = toread;
    return S_OK;
}

STDMETHODIMP CMemStream::Write(const void * pv, ULONG cb, ULONG * pcbWritten)
{
    ObjectLock lock_(this);
    ULONG towrite = min(cb , m_cb - m_seekptr);
    memcpy(m_pb + m_seekptr, pv, towrite);
    m_seekptr += towrite;
    if(pcbWritten)
        *pcbWritten = towrite;
    return S_OK;
}