// MemStream.h : Declaration of the CMemStream

#ifndef __MEMSTREAM_H_
#define __MEMSTREAM_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CMemStream
class ATL_NO_VTABLE CMemStream : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CMemStream, &CLSID_MemStream>,
	public IStream
{
public:
	CMemStream()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_MEMSTREAM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMemStream)
	COM_INTERFACE_ENTRY(IStream)
END_COM_MAP()

    void init(void* pb, ULONG cb);

public:
// IStream
	STDMETHOD(Seek)(_LARGE_INTEGER dlibMove, ULONG dwOrigin, _ULARGE_INTEGER * plibNewPosition);
	STDMETHOD(SetSize)(_ULARGE_INTEGER libNewSize);
	STDMETHOD(CopyTo)(IStream * pstm, _ULARGE_INTEGER cb, _ULARGE_INTEGER * pcbRead, _ULARGE_INTEGER * pcbWritten);
	STDMETHOD(Commit)(ULONG grfCommitFlags);
	STDMETHOD(Revert)();
	STDMETHOD(LockRegion)(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, ULONG dwLockType);
	STDMETHOD(UnlockRegion)(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, ULONG dwLockType);
	STDMETHOD(Stat)(tagSTATSTG * pstatstg, ULONG grfStatFlag);
	STDMETHOD(Clone)(IStream * * ppstm);
	STDMETHOD(Read)(void * pv, ULONG cb, ULONG * pcbRead);
	STDMETHOD(Write)(const void * pv, ULONG cb, ULONG * pcbWritten);

    
private:
    BYTE* m_pb;
    ULONG m_cb;
    ULONG m_seekptr;
};

#endif //__MEMSTREAM_H_
