// OutputStream.h : Declaration of the COutputStream

#ifndef __OUTPUTSTREAM_H_
#define __OUTPUTSTREAM_H_

#include "resource.h"       // main symbols

class CConnector;
/////////////////////////////////////////////////////////////////////////////
// COutputStream
class ATL_NO_VTABLE COutputStream : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<COutputStream, &CLSID_OutputStream>,
	public ISupportErrorInfoImpl<&IID_IStream>,
    public IStream,
    public IGetParserSource,
    public IParserSource
{
public:
	COutputStream()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_OUTPUTSTREAM)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(COutputStream)
	COM_INTERFACE_ENTRY(IStream)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IGetParserSource)
	COM_INTERFACE_ENTRY(IParserSource)
END_COM_MAP()

public:
    void init(CConnector* pConn);

private:
    CConnector* m_pConn;

public:    
// IStream
	STDMETHOD(Seek)(_LARGE_INTEGER dlibMove, ULONG dwOrigin, _ULARGE_INTEGER * plibNewPosition);
	STDMETHOD(SetSize)(_ULARGE_INTEGER libNewSize);
	STDMETHOD(CopyTo)(IStream * pstm, _ULARGE_INTEGER cb, _ULARGE_INTEGER * pcbRead, _ULARGE_INTEGER * pcbWritten);
	STDMETHOD(Commit)(ULONG grfCommitFlags);
	STDMETHOD(Revert)();
	STDMETHOD(LockRegion)(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, ULONG dwLockType);
	STDMETHOD(UnlockRegion)(_ULARGE_INTEGER libOffset, _ULARGE_INTEGER cb, ULONG dwLockType);
	STDMETHOD(Stat)(tagSTATSTG * pstatstg, ULONG grfStatFlag);
	STDMETHOD(Clone)(IStream * * ppstm);
	STDMETHOD(Read)(void * pv, ULONG cb, ULONG * pcbRead);
	STDMETHOD(Write)(const void * pv, ULONG cb, ULONG * pcbWritten);

// IGetParserSource
	STDMETHOD(get_ParserSource)(IParserSource * * par_value);
// IParserSource
	STDMETHOD(get_Property)(BSTR par_name, VARIANT * par_value);
	STDMETHOD(put_Property)(BSTR par_name, VARIANT par_value);
	STDMETHOD(BeginReceiving)(ISequentialStream * * par_stream);
	STDMETHOD(EndReceiving)();
};

#endif //__OUTPUTSTREAM_H_
