	
// TViewProxy.h : Declaration of the CTViewProxy

#ifndef __TVIEWPROXY_H_
#define __TVIEWPROXY_H_

#include "resource.h"       // main symbols

using namespace _com_util;
/////////////////////////////////////////////////////////////////////////////
// CTViewProxy
class ATL_NO_VTABLE CTViewProxy : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CTViewProxy, &CLSID_TViewProxy>,
	public IDispatchImpl<ITView, &IID_ITView, &LIBID_TVIEWMTSLib>
{
public:
	CTViewProxy()
	{
		m_pUnkMarshaler = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TVIEWPROXY)
DECLARE_GET_CONTROLLING_UNKNOWN()

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CTViewProxy)
	COM_INTERFACE_ENTRY(ITView)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_ISoapProxy, m_spSoapProxyUnk.p)
END_COM_MAP()

	HRESULT FinalConstruct()
	{
		HRESULT hr = m_spSoapProxy.CreateInstance(CLSID_SoapProxy);
        if(SUCCEEDED(hr))
        {
            m_spSoapProxy->QueryInterface(IID_IUnknown, (void**)&m_spSoapProxyUnk);
            hr = CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
        }
        try
        {
            m_spSoapProxy->Initialize(L"http://ivan/TView/TView.wsdl", L"http://ivan/TView/TView.wsml", L"TView", L"TViewSoapPort");
        }
        catch(_com_error & e)
        {
            hr = e.Error();
        }
        return hr;
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
        m_spSoapProxy.Release();
        m_spSoapProxyUnk.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;
    CComPtr<IUnknown> m_spSoapProxyUnk;
    ISoapProxyPtr m_spSoapProxy;


// ITViewProxy
public:
// ITView
	STDMETHOD(ShutdownMachine)(LONG nFlags)
	{
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"ShutdownMachine");
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"nFlags"))
                        spMap->ComValue = nFlags;
                }
                else
                    break;
            }
            m_spSoapProxy->Execute(spOp);
        }
        catch(_com_error & e)
        {
            return e.Error();
        }
        return S_OK;
	}
	STDMETHOD(GetProcesses)(_Recordset * * ppRecordset)
	{
		if (ppRecordset == NULL)
			return E_POINTER;
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"GetProcesses");
            m_spSoapProxy->Execute(spOp);
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"Result"))
                    {
                        CheckError(spMap->ComValue.punkVal->QueryInterface(IID__Recordset, (void**)ppRecordset));
                    }
                }
                else
                    break;
            }
        }
        catch(_com_error & e)
        {
            return e.Error();
        }			
		return S_OK;
	}
	STDMETHOD(KillProcess)(LONG processID)
	{
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"KillProcess");
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"processID"))
                        spMap->ComValue = processID;
                }
                else
                    break;
            }
            m_spSoapProxy->Execute(spOp);
        }
        catch(_com_error & e)
        {
            return e.Error();
        }
        return S_OK;
	}
	STDMETHOD(DebugProcess)(LONG processID)
	{
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"DebugProcess");
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"processID"))
                        spMap->ComValue = processID;
                }
                else
                    break;
            }
            m_spSoapProxy->Execute(spOp);
        }
        catch(_com_error & e)
        {
            return e.Error();
        }
        return S_OK;
	}
	STDMETHOD(GetModules)(LONG processID, _Recordset * * ppRecordset)
	{
		if (ppRecordset == NULL)
			return E_POINTER;
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"GetModules");
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"processID"))
                        spMap->ComValue = processID;
                }
                else
                    break;
            }
            m_spSoapProxy->Execute(spOp);
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"Result"))
                    {
                        CheckError(spMap->ComValue.punkVal->QueryInterface(IID__Recordset, (void**)ppRecordset));
                    }
                }
                else
                    break;
            }

        }
        catch(_com_error & e)
        {
            return e.Error();
        }			
		return S_OK;
	}
	STDMETHOD(GetMemory)(LONG processID, _Recordset * * ppRecordset)
	{
		if (ppRecordset == NULL)
			return E_POINTER;
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"GetMemory");
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"processID"))
                        spMap->ComValue = processID;
                }
                else
                    break;
            }
            m_spSoapProxy->Execute(spOp);
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"Result"))
                    {
                        CheckError(spMap->ComValue.punkVal->QueryInterface(IID__Recordset, (void**)ppRecordset));
                    }
                }
                else
                    break;
            }

        }
        catch(_com_error & e)
        {
            return e.Error();
        }						
		return S_OK;
	}
	STDMETHOD(GetHandles)(LONG processID, _Recordset * * ppRecordset)
	{
		if (ppRecordset == NULL)
			return E_POINTER;
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"GetHandles");
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"processID"))
                        spMap->ComValue = processID;
                }
                else
                    break;
            }
            m_spSoapProxy->Execute(spOp);
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"Result"))
                    {
                        CheckError(spMap->ComValue.punkVal->QueryInterface(IID__Recordset, (void**)ppRecordset));
                    }
                }
                else
                    break;
            }

        }
        catch(_com_error & e)
        {
            return e.Error();
        }						
		return S_OK;
	}
	STDMETHOD(GetEnvironment)(LONG processID, _Recordset * * ppRecordset)
	{
		if (ppRecordset == NULL)
			return E_POINTER;
		try
        {
            IWSDLOperationPtr spOp = 
                m_spSoapProxy->GetOperation(L"GetEnvironment");
            IEnumSoapMappersPtr spEnum;
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"processID"))
                        spMap->ComValue = processID;
                }
                else
                    break;
            }
            m_spSoapProxy->Execute(spOp);
            spOp->GetOperationParts(&spEnum);
            while(true)
            {
                long l = 0;
                ISoapMapperPtr spMap;
                spEnum->Next(1, &spMap, &l);
                if(l == 1)
                {
                    if(spMap->PartName == _bstr_t(L"Result"))
                    {
                        CheckError(spMap->ComValue.punkVal->QueryInterface(IID__Recordset, (void**)ppRecordset));
                    }
                }
                else
                    break;
            }

        }
        catch(_com_error & e)
        {
            return e.Error();
        }								
		return S_OK;
	}
};

#endif //__TVIEWPROXY_H_
